{program rxSerialDemo.spin
author: Tracy Allen, EME Systems
version 2 of the demo, now incorporates rxSerialChallenger2, so test data comes from a pin on the same cog.
Demo of rxSerial_ta_10
rxSerial_ta_10 is a receive only uart, motivated by a need for low power operation at up to 115200 baud even with clkfreq=5MHz.
At higher clkfreq, correspondingly higher baud rates possible.

This demo uses fullDuplexSerial at low baud rate to retransmit received data to a PC terminal for verification.

The rxSerialChallenger2 program sends data from another pin on the same prop (or another one) at the high baud rate.
rxpin and txpin should be linked together, ground also if they are on different props.

--current drain, rxSerial + fullDuplexSerial (4 cogs active):
      xtal1   1.3 mA       5 MHz
      + PLL2x  2.7mA    10 MHz
      + PLL4x	4.7mA   20 MHz
      + PLL8x  8.8 mA   40 MHz
      + PLL16x   17 mA  80 MHz
}

CON
  _CLKMODE = XTAL1      ' + pll2x
  _XINFREQ = 5_000_000

  rxpin = 15       ' main serial burst input to the rxserial routine
  baudrx = 115200

  txpin = 1       ' pin used by the challenger cog to send serial packets to rxserial
  baudtx = 115200 ' it is possible to test mismatch of baud rates.

VAR
  long   stack[32]
  byte char

OBJ
  fds : "fullduplexserial"           ' this picks up the received data and shows it on the debug screen
  rx: "rxSerial_ta_10"               ' this is the receive routine being demo'd
  challenger: "rxSerialChallenger2"  ' this uses another cog to send a text string (at full speed, from cog ram)

PUB main
  outa[0..27]~                  ' peg all unused pins, adjust for situation
  dira[0..27]~~
  dira[rxpin]~                  ' serial receive from 2nd source
  outa[txpin]~~                 ' inhibit serial transmission, note txpin is linked to rxpin
  rx.start(rxpin,0,baudrx)
  fds.start(31,30,0,2400)       ' for debug output
  pause(200)
  fds.str(string(13,"baudrx= "))
  fds.dec(baudrx)
  fds.str(string("     bitticks= "))  ' show the time allowed per bit, in prop clock ticks.
  fds.dec(clkfreq/baudrx)
  fds.tx(13)
  challenger.start(txpin,baudtx,1000)   ' send a challenge packet every 1000 milliseconds
  pause(50)
  outa[txpin]~                  ' now release the txpin to control by the challenger cog

  repeat                        ' receive and debug
    char := rx.rx
    fds.tx(char)


PRI pause(ms)
  waitcnt(clkfreq/1000*ms + cnt)

